#include "fxlib.h"
#include "stdio.h"
#include "epsilon.h"

unsigned long im2_C0[] = {
0x00000000,0x00000000,0x00000000,0x00000000,0x7FFFFFFF,0xFFFFFFFF,0xFFFFFFFE,0x0FE03FFE,0x7FFFFFFF,0xFFFFFFFF,
0xFFFC1E0E,0xAFEABFFE,0x7F83FFF3,0xFFC1F3FF,0xFFFD5EAE,0x0FE03FC0,0x7E01FFF3,0xFF00F3BF,0xFFFC1E0E,0xAFEAB054,
0x7C78FFF3,0xFE3C7F3F,0xFFFD02AE,0x03E01540,0x7CFCF0E7,0x867E6413,0xCFFC2A00,0xAB095054,0x78FFE066,0x007FE413,
0x9FFD02AA,0x03401540,0x79FFCE66,0x70FFE673,0x9FFC2A00,0xAB095014,0x79FFFE64,0xFCFFE673,0x3FFD02AA,0x00400500,
0x79FFC064,0xFCFFE673,0x3FE02A00,0xA9094014,0x79F99CE4,0xFCFCE67A,0x7FEA00AA,0x00400500,0x78F39CCC,0xE479CCF8,
0x7F002800,0xA9094014,0x7C0380CE,0x0601CC38,0xFF4A00A4,0x00400500,0x7E0FC4CF,0x0F07CC38,0xFF000000,0x00000014,
0x7FFFFFFF,0xFFFFFFF9,0xFE000000,0x00000000,0x7FFFFFFF,0xFFFFFFC1,0xFC000000,0x00000000,0x7FFFFFFF,0xFFFFFFC3,
0xFFFFFFFF,0xFFFF0FFE,0x7FFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFE1FFE,0x7FFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFC1FFE,
0x7FFFFDFF,0x1FFFFFF8,0x3FFFFFFF,0xFFF83FFE,0x7FFFFAFE,0xEFFFFFFB,0xDFFFFFFF,0xFFF03FFE,0x7FFFFAFD,0xF63438FB,
0xD77FFFFF,0xFFE27FFE,0x7FFFFAFD,0xFDD2D778,0x177FFFFF,0xFFD97FFE,0x7FFFF77D,0xC616D07B,0xDAFFFFFF,0xFFA6FFFE,
0x7FFFF07D,0xF5D6D7FB,0xDAFFFFFF,0xFF7EFFFE,0x7FFFEFBE,0xED96D77B,0xDDFFFFFF,0xFEC5FFFE,0x7FFFEFBF,0x1E56D8F8,
0x3DFFFFFF,0xFD85FFFE,0x7FFFFFFF,0xFFFFFFFF,0xFDFFFFFF,0xFB0BFFFE,0x7FFFFFFF,0xFFFFFFFF,0xFBFFFFFF,0xF71BFFFE,
0x7FFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xEFF7FFFE,0x7FFEFBFF,0xFFFFFDFF,0x83FFFFFF,0xDFF7FFFE,0x7FFE73FF,0xFFFFFDFF,
0xBDFFFFFF,0xBFEFFFFE,0x7FFE7318,0x61C7E58F,0xBD8E3FFF,0x71EFFFFE,0x7FFEAAEB,0xAEBBD977,0x8175DFFE,0xE1DFFFFE,
0x7FFEAA0B,0xAEBBDD07,0xBD067FFD,0xC1DFFFFE,0x7FFEAAFB,0xAEBBDD7F,0xBD7FBFFB,0xC3BFFFFE,0x7FFEDAEB,0xAEBBD977,
0xBD75DFF7,0x87BFFFFE,0x7FFEDB1B,0xAEC7E58F,0x838E3FEF,0x877FFFFE,0x7FFFFFFF,0xFFFFFFFF,0xFFFFFFDF,0xFF7FFFFE,
0x7FFFFFFF,0xFFFFFFFF,0xFFFFFFBF,0xFEFFFFFE,0x7FFFFFFF,0xFFFFFFFF,0xFFFFFF7F,0xFEFFFFFE,0x7FFFFFFF,0xF1C7183F,
0xFFFFFEF8,0x3DFFFFFE,0x7FFFFFFF,0xEEBAEF7F,0xFFFFFDF0,0x7DFFFFFE,0x7FFFFFFF,0xFEBAEF7F,0xFFFFFBE0,0x7BFFFFFE,
0x7FFFFFFF,0xFEBAEEFF,0xFFFFF7C0,0xFBFFFFFE,0x7FFFFFFF,0xFDBAEEFF,0xFFFFEF81,0xF7FFFFFE,0x7FFFFFFF,0xFBBAEDFF,
0xFFFFDF81,0xF7FFFFFE,0x7FFFFFFF,0xF7BAEDFF,0xFFFFBF03,0xEFFFFFFE,0x7FFFFFFF,0xE0C71DFF,0xFFFF7E07,0xEFFFFFFE,
0x7FFFFFFF,0xFFFFFFFF,0xFFFEFE07,0xDFFFFFFE,0x7FFFFFFF,0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFE,0x7FFFFFFF,0xFE3FFF7F,
0x7AFFFFBF,0xFFFFFFFE,0x7FFFFFFF,0xFDDFFFFF,0x77FFFFBF,0xFFFFFFFE,0x7775DD77,0x7BF8E363,0x6E872CB1,0xA1F8D65E,
0x76B5AD6B,0x7BF75D5D,0x4EBACB2E,0x96F74D9E,0x7AAEABAA,0xFBF8675D,0x2EBAEBAE,0xB6F75DDE,0x7AAEABAA,0xFBF77B5D,
0x76BAEBAE,0xB6F75DDE,0x7DDF77DD,0xFDD65D5D,0x76BACB2E,0xB6F75D9E,0x7DDF77DD,0xEE396363,0x7ABB2CB1,0xB6D8DE5E,
0x7FFFFFFF,0xFFFFFFFF,0xFFFFEFFF,0xFFFFFFDE,0x7FFFFFFF,0xFFFFFFFF,0xFFFE1FFF,0xFFFFFC3E,0x7FFFFFFF,0xFFFFFFFF,
0xFFFFFFFF,0xFFFFFFFE,0x00000000,0x00000000,0x00000000,0x00000000};

int x_mov,y_mov;
int x_mouse=64;
int y_mouse=33;
int x_mouse_min=7;
int x_mouse_max=120;
int y_mouse_min=4;
int y_mouse_max=59;
int menu,F1,F2,F3,F4,F5,F6;
int x_choice,y_choice,build_choice,build_mode,cost,x_loc,y_loc;
long treasure=5000000;
extern unsigned char map_1[50][50];
int powersupply,watersupply;
long population;
int rnd_cnt;
extern exit,gamesp,firehazard,l,k;
int menucounter;
extern fire_ar[3][3];
extern nuclear_ar[1][3];
extern nuclear;
extern fire_x,fire_y,disaster_bool,pos;
int zoom;
int infomode;
int animation=1;
int showFPS=0;



void intro(){
		DISPGRAPH picture;
		GRAPHDATA picture_info;
		picture_info.width = 128;						
		picture_info.height = 64;
		picture_info.pBitmap = (unsigned long*)im2_C0;
		picture.x = 0;
		picture.y = 0;
		picture.GraphData = picture_info;
		picture.WriteModify = IMB_WRITEMODIFY_NORMAL;
		picture.WriteKind = IMB_WRITEKIND_OR;
		Bdisp_AllClr_DDVRAM();
		Bdisp_WriteGraph_VRAM(&picture);
		Bdisp_PutDisp_DD();

Sleep(2000);
}

void exit_screen(){
								Bdisp_AllClr_DDVRAM();
								PopUpWin(6);
								PrintMini(42, 8, (unsigned char *)"*Credits*", MINI_OVER);
								PrintMini(20, 21, (unsigned char *)"Game Concept: EA/Maxis", MINI_OVER);
								PrintMini(20, 28, (unsigned char *)"File operations: VanHoa", MINI_OVER);
								PrintMini(24, 35, (unsigned char *)"Uses Kucalc's Epsilon", MINI_OVER);
								PrintMini(26, 42, (unsigned char *)"Code: Menno de Bes", MINI_OVER);
								PrintMini(20, 52, (unsigned char *)"www.CasioKingdom.org", MINI_OVER);
								
								Bdisp_PutDisp_DD();
								Sleep(500);
}


int AddIn_main(int isAppli, unsigned short OptionNum){ 
CPUSpeedNormal();
CPUSpeedDouble();

Bdisp_AllClr_DDVRAM();
intro();
Bdisp_AllClr_DDVRAM();
draw_screen();

    while(1){	
	Bdisp_AllClr_VRAM();RestoreDisp(1);	
	if(animation==1){wave_water();}
	draw_map();
	time();	
	if(menu==0){checkmap();}
	draw_menu();
	draw_mouse();

		if(IsKeyDown(KEY_CTRL_MENU)==1&menu==0){zoom=0;menu=1;menucounter=0;}
		menucounter=menucounter+1;
		if(menucounter>30000){menucounter=0;}
		if(IsKeyDown(KEY_CTRL_MENU)){}	
		if(IsKeyDown(KEY_CTRL_F1)==1){menu=1,F1=1,F2=0,F3=0,F4=0,F5=0,F6=0;build_choice=0,build_mode=0;x_mouse=7;y_mouse=49;zoom=0;infomode=0;}
		if(IsKeyDown(KEY_CTRL_F2)==1){menu=1,F1=0,F2=1,F3=0,F4=0,F5=0,F6=0;build_choice=0,build_mode=0;x_mouse=25;y_mouse=49;zoom=0;infomode=0;}
		if(IsKeyDown(KEY_CTRL_F4)==1){menu=1,F1=0,F2=0,F3=0,F4=1,F5=0,F6=0;build_choice=0,build_mode=0;infomode=0;}
		if(IsKeyDown(KEY_CTRL_F5)==1){menu=1,F1=0,F2=0,F3=0,F4=0,F5=1,F6=0;build_choice=0,build_mode=0;infomode=0;}
		if(IsKeyDown(KEY_CTRL_F6)==1){menu=1,F1=0,F2=0,F3=0,F4=0,F5=0,F6=1;build_choice=0,build_mode=0;infomode=0;}

		if(IsKeyDown(KEY_CTRL_MENU)==1&menu==1&menucounter>10){menu=0;F1=0,F2=0,F3=0,F4=0,F5=0,F6=0;build_choice=0,build_mode=0;infomode=0;}
		if(IsKeyDown(KEY_CTRL_EXIT)==1&menu==1){menu=0;F1=0,F2=0,F3=0,F4=0,F5=0,F6=0;build_choice=0,build_mode=0;infomode=0;}

		if(build_mode==1){F1=0;F2=0;F3=0;F4=0;F5=0;F6=0;}
		
		rnd_cnt=rnd_cnt+1;
		if(rnd_cnt>2000){rnd_cnt=0;}

				srand((unsigned)RTCReadSecond()*RTCReadMinute()*RTCReadHour());

				if(disaster_bool==1){
					if(firehazard>300&fire_ar[0][2]==0&rnd_cnt>1000&menu==0){
						if((int)rand()%100>98){firedisaster();}
					}
				}

				if(disaster_bool==1){
					if(nuclear==1&rnd_cnt>1500&menu==0){
						if((int)rand()%10000>9998){nucleardisaster();}
					}
				}


				if(fire_ar[0][2]>5){fire_ar[0][2]=fire_ar[0][2]-1;}
				if(fire_ar[0][2]<=5&fire_ar[0][2]>0){map_1[fire_ar[0][0]][fire_ar[0][1]]=2;fire_ar[0][0]=0;fire_ar[0][1]=0;fire_ar[0][2]=0;}
				if(disaster_bool==1&menu==0&rnd_cnt>1000){if((int)rand()%1000>997){earthquake();}}

				if(menu==0&rnd_cnt>1500&population>5000){if((int)rand()%1000>997){price();rnd_cnt=0;}}
				if(menu==0&rnd_cnt>1600&treasure>10000){if((int)rand()%1000>997){stolen();rnd_cnt=0;}}

	Bdisp_PutDisp_DD();		
		if(F1==0&F2==0&F3==0&F4==0&F5==0&F6==0&build_mode==0&infomode==0){
			if(IsKeyDown(KEY_CTRL_DOWN)){y_mouse=y_mouse+10;}
			if(IsKeyDown(KEY_CTRL_UP)){y_mouse=y_mouse-10;}
			if(IsKeyDown(KEY_CTRL_LEFT)){x_mouse=x_mouse-10;}
			if(IsKeyDown(KEY_CTRL_RIGHT)){x_mouse=x_mouse+10;}
			x_mouse_min=7;
			x_mouse_max=120;
			y_mouse_min=4;
			y_mouse_max=59;
		}

		if(F4==1&menu==1){tax();}
		if(F5==1&menu==1){info();}
		if(F6==1&menu==1){enddialog();}

		if(F1==1&menu==1){
			if(IsKeyDown(KEY_CTRL_DOWN)){y_mouse=y_mouse+9;}
			if(IsKeyDown(KEY_CTRL_UP)){y_mouse=y_mouse-9;}
			if(IsKeyDown(KEY_CTRL_LEFT)){x_mouse=x_mouse-9;}
			if(IsKeyDown(KEY_CTRL_RIGHT)){x_mouse=x_mouse+9;}
			x_mouse_min=7;
			x_mouse_max=25;
			y_mouse_min=13;
			y_mouse_max=49;

			if(IsKeyDown(KEY_CTRL_EXE)){
				x_choice=((x_mouse-7)/9)+1;
				y_choice=((y_mouse-13)/9)+1;
				if(x_choice==1&y_choice==1){build_choice=2;cost=10;}/*demolish*/
				if(x_choice==2&y_choice==1){build_choice=0;cost=15;}/*water*/
				if(x_choice==3&y_choice==1){build_choice=19;cost=15;}/*tree*/
				if(x_choice==1&y_choice==2){build_choice=30;cost=100;}/*house1*/
				if(x_choice==2&y_choice==2){build_choice=31;cost=150;}/*house2*/
				if(x_choice==3&y_choice==2){build_choice=32;cost=200;}/*house3*/
				if(x_choice==1&y_choice==3){build_choice=33;cost=50;}/*comercial1*/
				if(x_choice==2&y_choice==3){build_choice=34;cost=100;}/*comercial2*/
				if(x_choice==3&y_choice==3){build_choice=35;cost=150;}/*comercial3*/
				if(x_choice==1&y_choice==4){build_choice=36;cost=200;}/*factory1*/
				if(x_choice==2&y_choice==4){build_choice=37;cost=300;}/*factory2*/
				if(x_choice==3&y_choice==4){build_choice=38;cost=400;}/*factory3*/
				if(x_choice==1&y_choice==5){build_choice=39;cost=50;}/*Agri1*/
				if(x_choice==2&y_choice==5){build_choice=40;cost=75;}/*Agri2*/
				if(x_choice==3&y_choice==5){build_choice=41;cost=100;}/*Agri3*/
				x_mouse=0;
				y_mouse=0;
				build_mode=1;
			}
		}


		if(F2==1&menu==1){
			if(IsKeyDown(KEY_CTRL_DOWN)){y_mouse=y_mouse+9;}
			if(IsKeyDown(KEY_CTRL_UP)){y_mouse=y_mouse-9;}
			if(IsKeyDown(KEY_CTRL_LEFT)){x_mouse=x_mouse-9;}
			if(IsKeyDown(KEY_CTRL_RIGHT)){x_mouse=x_mouse+9;}
			x_mouse_min=25;
			x_mouse_max=52;
			y_mouse_min=13;
			y_mouse_max=49;

			if(IsKeyDown(KEY_CTRL_EXE)){
				x_choice=((x_mouse-25)/9)+1;
				y_choice=((y_mouse-13)/9)+1;
				if(x_choice==1&y_choice==1){build_choice=50;cost=10;}/*road*/			
				if(x_choice==2&y_choice==1){build_choice=255;cost=500;}/*harbour*/
				if(x_choice==3&y_choice==1){build_choice=46;cost=3500;}/*airport*/
				if(x_choice==4&y_choice==1){build_choice=130;cost=50;}/*rail*/

				if(x_choice==1&y_choice==2){build_choice=61;cost=500;}/*powerstation_1*/
				if(x_choice==2&y_choice==2){build_choice=62;cost=1000;}/*powerstation_2*/
				if(x_choice==3&y_choice==2){build_choice=63;cost=25000;}/*powerstation_3*/
				if(x_choice==4&y_choice==2){build_choice=108;cost=2500;}/*garbage*/

				if(x_choice==1&y_choice==3){build_choice=64;cost=50;}/*waterstation*/
				if(x_choice==2&y_choice==3){build_choice=71;cost=250;}/*Sport*/	
				if(x_choice==3&y_choice==3){build_choice=70;cost=150;}/*playground*/
				if(x_choice==4&y_choice==3){build_choice=104;cost=10000;}/*stadium*/
					
				if(x_choice==1&y_choice==4){build_choice=65;cost=250;}/*policestation*/
				if(x_choice==2&y_choice==4){build_choice=66;cost=250;}/*firestation*/
				if(x_choice==3&y_choice==4){build_choice=72;cost=250;}/*hospital*/	
				if(x_choice==4&y_choice==4){build_choice=116;cost=2500;}/*tauw*/	

				if(x_choice==1&y_choice==5){build_choice=67;cost=250;}/*school1*/
				if(x_choice==2&y_choice==5){build_choice=68;cost=500;}/*school2*/
				if(x_choice==3&y_choice==5){build_choice=69;cost=2500;}/*school3*/
				if(x_choice==4&y_choice==5){build_choice=100;cost=2500;}/*church*/


				x_mouse=0;
				y_mouse=0;
				build_mode=1;
			}
		}





		
		if(build_mode==1){
			if(IsKeyDown(KEY_CTRL_DOWN)){y_mouse=y_mouse+15;}
			if(IsKeyDown(KEY_CTRL_UP)){y_mouse=y_mouse-15;}
			if(IsKeyDown(KEY_CTRL_LEFT)){x_mouse=x_mouse-15;}
			if(IsKeyDown(KEY_CTRL_RIGHT)){x_mouse=x_mouse+15;}
			x_mouse_min=11;
			x_mouse_max=116;
			y_mouse_min=8;
			y_mouse_max=53;

			
			
			if(IsKeyDown(KEY_CTRL_SHIFT)){
				x_loc=x_mov+(x_mouse/15);
				y_loc=y_mov+(y_mouse/15);
				if(treasure>=cost){
				
				
									if(build_choice==255){
										if(map_1[y_loc][x_loc]!=0&map_1[y_loc][x_loc-1]==0){build_choice=42;}
										if(map_1[y_loc][x_loc]!=0&map_1[y_loc][x_loc+1]==0){build_choice=43;}
										if(map_1[y_loc][x_loc]!=0&map_1[y_loc-1][x_loc]==0){build_choice=44;}
										if(map_1[y_loc][x_loc]!=0&map_1[y_loc+1][x_loc]==0){build_choice=45;}
											if(map_1[y_loc][x_loc-1]!=0&map_1[y_loc][x_loc+1]!=0&map_1[y_loc-1][x_loc]!=0&map_1[y_loc+1][x_loc]!=0){
												Bdisp_AreaReverseVRAM(x_mouse-6,y_mouse-6,x_mouse+6,y_mouse+7);	
												Bdisp_PutDisp_DD();
												Sleep(100);
												PopUpWin(1);
												locate(3,4);	
												Print((unsigned char*)"Build near water!");
												Bdisp_PutDisp_DD();
												Sleep(400);
											}
											if(map_1[y_loc][x_loc]==0){
												Bdisp_AreaReverseVRAM(x_mouse-6,y_mouse-6,x_mouse+6,y_mouse+7);	
												Bdisp_PutDisp_DD();
												Sleep(100);
												PopUpWin(2);
												locate(4,3);
												Print((unsigned char*)"You can't build");
												locate(7,4);
												Print((unsigned char*)"on water! ");
												Bdisp_PutDisp_DD();
												Sleep(400);
											}
									}




					if(build_choice!=255){
							if(map_1[y_loc][x_loc]<19){
								if(map_1[y_loc][x_loc]!=0){
									if(build_choice!=2){
										if(build_choice!=63&build_choice!=46&build_choice!=69&build_choice!=100&build_choice!=104&build_choice!=108){
											map_1[y_loc][x_loc]=build_choice;treasure=treasure-cost;
										}
									}
								}
							}



						if(build_choice==2&map_1[y_loc][x_loc]!=2&map_1[y_loc][x_loc]!=99){
							map_1[y_loc][x_loc]=build_choice;treasure=treasure-cost;
						}

						if(build_choice==46){
							if(pos==1&map_1[y_loc][x_loc]!=0&map_1[y_loc][x_loc]<19&map_1[y_loc+1][x_loc]!=0&map_1[y_loc+1][x_loc]<19){map_1[y_loc][x_loc]=48;map_1[y_loc+1][x_loc]=49;treasure=treasure-cost;}
							if(pos==2&map_1[y_loc][x_loc]!=0&map_1[y_loc][x_loc]<19&map_1[y_loc-1][x_loc]!=0&map_1[y_loc-1][x_loc]<19){map_1[y_loc][x_loc]=49;map_1[y_loc-1][x_loc]=48;treasure=treasure-cost;}
							if(pos==3&map_1[y_loc][x_loc]!=0&map_1[y_loc][x_loc]<19&map_1[y_loc][x_loc+1]!=0&map_1[y_loc][x_loc+1]<19){map_1[y_loc][x_loc]=46;map_1[y_loc][x_loc+1]=47;treasure=treasure-cost;}
							if(pos==4&map_1[y_loc][x_loc]!=0&map_1[y_loc][x_loc]<19&map_1[y_loc][x_loc-1]!=0&map_1[y_loc][x_loc-1]<19){map_1[y_loc][x_loc]=47;map_1[y_loc][x_loc-1]=46;treasure=treasure-cost;}
						}
						

						if(map_1[y_loc][x_loc]!=0&map_1[y_loc][x_loc]<19&map_1[y_loc][x_loc+1]!=0&map_1[y_loc][x_loc+1]<19&map_1[y_loc+1][x_loc]!=0&map_1[y_loc+1][x_loc]<19&map_1[y_loc+1][x_loc+1]!=0&map_1[y_loc+1][x_loc+1]<19&build_choice==69){map_1[y_loc][x_loc]=69;map_1[y_loc][x_loc+1]=73;map_1[y_loc+1][x_loc]=74;map_1[y_loc+1][x_loc+1]=75;treasure=treasure-cost;}
						if(map_1[y_loc][x_loc]!=0&map_1[y_loc][x_loc]<19&map_1[y_loc][x_loc+1]!=0&map_1[y_loc][x_loc+1]<19&map_1[y_loc+1][x_loc]!=0&map_1[y_loc+1][x_loc]<19&map_1[y_loc+1][x_loc+1]!=0&map_1[y_loc+1][x_loc+1]<19&build_choice==63){map_1[y_loc][x_loc]=63;map_1[y_loc][x_loc+1]=76;map_1[y_loc+1][x_loc]=77;map_1[y_loc+1][x_loc+1]=78;treasure=treasure-cost;}
						if(map_1[y_loc][x_loc]!=0&map_1[y_loc][x_loc]<19&map_1[y_loc][x_loc+1]!=0&map_1[y_loc][x_loc+1]<19&map_1[y_loc+1][x_loc]!=0&map_1[y_loc+1][x_loc]<19&map_1[y_loc+1][x_loc+1]!=0&map_1[y_loc+1][x_loc+1]<19&build_choice==100){map_1[y_loc][x_loc]=100;map_1[y_loc][x_loc+1]=101;map_1[y_loc+1][x_loc]=102;map_1[y_loc+1][x_loc+1]=103;treasure=treasure-cost;}
						if(map_1[y_loc][x_loc]!=0&map_1[y_loc][x_loc]<19&map_1[y_loc][x_loc+1]!=0&map_1[y_loc][x_loc+1]<19&map_1[y_loc+1][x_loc]!=0&map_1[y_loc+1][x_loc]<19&map_1[y_loc+1][x_loc+1]!=0&map_1[y_loc+1][x_loc+1]<19&build_choice==104){map_1[y_loc][x_loc]=104;map_1[y_loc][x_loc+1]=105;map_1[y_loc+1][x_loc]=106;map_1[y_loc+1][x_loc+1]=107;treasure=treasure-cost;}
						if(map_1[y_loc][x_loc]!=0&map_1[y_loc][x_loc]<19&map_1[y_loc][x_loc+1]!=0&map_1[y_loc][x_loc+1]<19&map_1[y_loc+1][x_loc]!=0&map_1[y_loc+1][x_loc]<19&map_1[y_loc+1][x_loc+1]!=0&map_1[y_loc+1][x_loc+1]<19&build_choice==108){map_1[y_loc][x_loc]=108;map_1[y_loc][x_loc+1]=109;map_1[y_loc+1][x_loc]=110;map_1[y_loc+1][x_loc+1]=111;treasure=treasure-cost;}
		
	

						if(build_choice==42|build_choice==43|build_choice==44|build_choice==45){build_choice=255;}

							if(map_1[y_loc][x_loc]==0&build_choice!=2&build_choice!=0){
								Bdisp_AreaReverseVRAM(x_mouse-6,y_mouse-6,x_mouse+6,y_mouse+7);	
								Bdisp_PutDisp_DD();
								Sleep(100);
								PopUpWin(2);
								locate(4,3);
								Print((unsigned char*)"You can't build");
								locate(7,4);
								Print((unsigned char*)"on water! ");
								Bdisp_PutDisp_DD();
								Sleep(400);
							}




	
					}

				if(build_choice==0|build_choice==2){check_road();}
				if(build_choice>=50&build_choice<=60){check_road();}
				if(build_choice>=130&build_choice<=140){check_road();}

				}
			}
		}

		if(infomode==1){
			if(IsKeyDown(KEY_CTRL_DOWN)){y_mouse=y_mouse+15;}
			if(IsKeyDown(KEY_CTRL_UP)){y_mouse=y_mouse-15;}
			if(IsKeyDown(KEY_CTRL_LEFT)){x_mouse=x_mouse-15;}
			if(IsKeyDown(KEY_CTRL_RIGHT)){x_mouse=x_mouse+15;}
			x_mouse_min=11;
			x_mouse_max=116;
			y_mouse_min=8;
			y_mouse_max=53;
						if(IsKeyDown(KEY_CTRL_EXE)){
							x_loc=x_mov+(x_mouse/15);
							y_loc=y_mov+(y_mouse/15);
							l=y_loc;
							k=x_loc;
							build_choice=map_1[l][k];
							get_info();
						}
		}



					if(x_mouse<x_mouse_min){x_mouse=x_mouse_min;}
					if(x_mouse>x_mouse_max){x_mouse=x_mouse_max;}
					if(y_mouse<y_mouse_min){y_mouse=y_mouse_min;}
					if(y_mouse>y_mouse_max){y_mouse=y_mouse_max;}

		if(F1==0&F2==0&F3==0&F4==0&F5==0&F6==0){
			
			if(y_mouse<y_mouse_min+1|y_mouse>y_mouse_max-1){
				if(IsKeyDown(KEY_CTRL_DOWN)){y_mov=y_mov+1;}
				if(IsKeyDown(KEY_CTRL_UP)){y_mov=y_mov-1;}
			}
	
			if(x_mouse<x_mouse_min+1|x_mouse>x_mouse_max-1){
				if(IsKeyDown(KEY_CTRL_LEFT)){x_mov=x_mov-1;}
				if(IsKeyDown(KEY_CTRL_RIGHT)){x_mov=x_mov+1;}
			}
		}

		if(IsKeyDown(KEY_CTRL_OPTN)){infomode=1;menu=1;build_mode=0;x_mouse=0;y_mouse=0;zoom=0;}

		if(IsKeyDown(KEY_CHAR_PLUS)&menu==0){zoom=0;infomode=0;}
		if(IsKeyDown(KEY_CHAR_MINUS)&menu==0){zoom=7;infomode=0;}


		if(x_mov<0){x_mov=0;}
		if(y_mov<0){y_mov=0;}
		if(x_mov>42-zoom){x_mov=42-zoom;}
		if(y_mov>46-(zoom*0.5)){y_mov=46-(zoom*0.5);}	

		if(exit==1){exit_screen();CPUSpeedNormal();Reset_Calc();return 1;}
		if(IsKeyDown(KEY_CTRL_SHIFT)==1&IsKeyDown(KEY_CTRL_EXIT)==1){exit=1;}
		if(IsKeyDown(KEY_CTRL_SHIFT)==1&IsKeyDown(KEY_CHAR_STORE)==1){save();}
		if(IsKeyDown(KEY_CTRL_SHIFT)==1&IsKeyDown(KEY_CHAR_PLUS)==1){load();}
		if(IsKeyDown(KEY_CTRL_SHIFT)==1&IsKeyDown(KEY_CHAR_1)==1){showFPS=showFPS+1;}
		if(IsKeyDown(KEY_CTRL_SHIFT)==1&IsKeyDown(KEY_CHAR_2)==1){animation=animation+1;}
		if(IsKeyDown(KEY_CTRL_SHIFT)==1&IsKeyDown(KEY_CHAR_3)==1){nucleardisaster();}
		if(animation>1){animation=0;}
		if(showFPS>1){showFPS=0;}

		Sleep(gamesp);
    }

}


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}
#pragma section

